# Change Log

## TimeAwareBPMN-js

v1.5.0 - 20220225

- Added a label (with minDuration and maxDuration) to the relative constraints and sequence flows using overlays. 
- Validated attribute isTrueBranch of outgoing sequenceFlows of split XORs, in CustomRemder.js and bpmnSetcstnuLabels.js

v1.4.1 - 20220127

- Changed README.md. The npm module Java cannot be installed with JDK 17. Updated installation instructions.
- Added package-lock.json to the repository 
- Changed function checkMinMax to be used to check elements, sequenceFlow and relativeConstraints
- Improved comments
- Used setExtensionElementValue from window.bpmnjs in bpmnSetcstnuLabels.js and cstnuChecked.js


v1.4.0 - 20211231

- Changed bpmn2cstnu, stopped using window and document to access JS objects (elements) to read the temporal constraint values. 
The translation into CSTNU is done using the information in the XML string (BPMN)
- Added test of the translation from BPMN to CSTNU using jest
- Updated examples
- Fixed minor bugs 

v1.3.0 - 20211205

- Added support of boundary events (interrupting and non-interrupting)
- Changed Value for LabeledValues in the CSTNU edges for relative constraints
- Updated examples
- Fixed bugs 

v1.2.1 - 20211118

-  Updated naming of nodes START and END in CSTNU

v1.2.1 - 20211117 

- Removed IntermediateCatchEvent-timerEventDefinition elements
- Added simple IntermediateThrowEvent (without eventDefinitions)
- Fixed change color in frames when name of the element has '_'

v1.2.0 - 20211116 

- Added DataObjectReference to the palette
- Allowed multiple inputs and outputs to ParallelGateway
- Fixed problem of value computation in SequenceFlows output from XOR
- Added IntermediateThrowEvents
- Changed, if a messageFlow is presented, show an error on -Propagate conditions- and before doing the verification
- Fixed problem with relative connections and start/end events

v1.1.0 - to be released 

- Fixed the syntax of XSD for temporal constraints specification in BPMN v2 documents.

v1.0.0 - 20210924

- Changed structure of extensionElements and updated get and set functions. 
- Updated README.md files 

v0.6.0 - 20210924

- Changed, tempcon attributes are saved as extensionElements
- Updated XML schema definition 
- Improved README.md 

v0.5.4 - 20210917

- Changed, inter-task are saved as extensionElements 
- Added line command configuration for CSTNU no-logging
- Changed inter-task for relative constraint
- Added XML schema definition (xsd)
- Changed, propositional labels can be edited 

v0.5.4 - 20210907

- Added CustomReplaceConnectionBehavior to manage the movement of inter-tasks' endpoints and do not change the to sequenceFlow. TODO the while the dagging the connector looks like a sequenceFlow, and when it finishes only the ending points are kept. See how this can be fixed.  

v0.5.3 - 20210904

- Removed SVG button, there is a problem with intertasks
- Changed attribute names, Proposition -> Observed proposition and Condition -> Propositional label
- Changed prefix `cstnu` to `tempcon` for temporal constraints attributes in BPMN XML files

v0.5.2 20210818

- Fixed bugs
- Corrected spelling errors and renamed files according to the paper naming used
- Changed package.json from the server to access also the client

v0.5.1 - 20210725

- Fixed bugs
- Added the option of adding the modules as plugins on the server and with minimal modifications on the client.
- Started the creation of the documentation
- Changed name to **TimeAwareBPMN-js**

## BPMN.io + TC evaluation 

v0.4.1 - 20210707

- Fixed bugs
- Reorganized the files in modules
- Changed name to **BPMN.io + TC evaluation**

## CSTNU_Camunda_web

v0.3.3 - 20210615

- Fixed bugs
- Removed elements not considered in the mapping BPMN CSTNU
- Connected with Java using serverHTTP.js without using temporal files

v0.3.2 - 20210603

- Fixed bugs
- Added import CSTNU minimized by the Java implementation and updated values
- Added import CSTNU_evaluation_info generated by the Java implementation to show status

v0.3.1 - 20210520

- Moved the implementation to a web version based on bpmn.io 
- Changed name to **CSTNU_Camunda_web**

## Camunda plug-in (desktop)

v0.2.5 - 20210512

- Fixed bugs about the comparison of minDuration and maxDuration
- Added intertask. Implementation using DataObjectReferences

v0.2.4 - 20210416

- Added modal to export a bpmn model to cstnu model (Using a different plugin)
- TODO: combine the two plugins

v0.2.3 - 20210409

- Improved visual / user experience

v0.2.2 - 20210402

- Added temporal constraints to more elements 
- Added validation of minDuration `>` 0 and maxDiration `<` minDuration

v0.2.1 - 20210323

- Added temporal constraints to more elements 

v0.2.0 - 20210321

- Added custom pallet
- Added custom render for selected elements 

v0.1.0  -  20210312

- Added panel properties to selected elements (UserTask)


